/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTInteger_h__
#define __RTInteger_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTInteger : public RTDataObject
{
public:
    int                     value;

			    RTInteger( int = 0 ); //lint !e1931
			    RTInteger( const RTInteger & );
    virtual                 ~RTInteger( void );

    RTS_INLINE              operator int( void ) const;
    RTInteger             & operator=( int );
    RTInteger             & operator=( const RTInteger & );

    virtual int             operator==( const RTDataObject & ) const;

    RTS_INLINE int          operator ~ ( void ) const;
    RTS_INLINE int          operator ! ( void ) const;

    // prefix forms (e.g. ++i)
    RTS_INLINE RTInteger &  operator++( void );
    RTS_INLINE RTInteger &  operator--( void );

#if INTEGER_POSTFIX
    // Many, but not all, compilers support these postfix operators.

    RTS_INLINE int          operator++( int );
    RTS_INLINE int          operator--( int );
#endif

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTInteger ( RTInteger::classData )
};

extern const RTInteger EmptyInteger;
extern const RTInteger DefaultDelay;

struct RTTypedValue_RTInteger
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTInteger( const RTInteger      & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTInteger( const RTInteger      &,
				       const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTInteger.inl>
#endif

#endif // __RTInteger_h__
