/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTInterval_h__
#define __RTInterval_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTFieldDescriptor_h__
#include <RTFieldDescriptor.h>
#endif

#ifndef __RTObject_class_h__
#include <RTObject_class.h>
#endif

class RTInterval
{
public:
		    RTInterval( void );
    explicit        RTInterval( unsigned long centisec );
		    RTInterval( long sec, long usec );
		    RTInterval( const RTInterval & );
    RTS_INLINE      ~RTInterval( void );

    RTInterval    & operator= ( const RTInterval & );
    RTInterval    & operator+=( const RTInterval & );
    RTInterval    & operator-=( const RTInterval & );

    int             isset( void ) const;
    int             is0( void ) const;
    int             le0( void ) const;
    int             ge0( void ) const;
    int             gt0( void ) const;

    unsigned long   ticks( void ) const;
    RTS_INLINE long seconds( void ) const;
    RTS_INLINE long micros( void ) const;

    static const RTObject_class classData;

#define RTType_RTInterval ( RTInterval::classData )

private:
    long            sec;
    long            usec;

    static const RTFieldDescriptor fieldData[];
};

int            operator< ( const RTInterval &, const RTInterval & );
RTS_INLINE int operator==( const RTInterval &, const RTInterval & );
RTS_INLINE int operator> ( const RTInterval &, const RTInterval & );
RTInterval     operator+ ( const RTInterval &, const RTInterval & );
RTInterval     operator- ( const RTInterval &, const RTInterval & );
RTS_INLINE int operator>=( const RTInterval &, const RTInterval & );
RTS_INLINE int operator!=( const RTInterval &, const RTInterval & );
RTS_INLINE int operator<=( const RTInterval &, const RTInterval & );

struct RTTypedValue_RTInterval
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTInterval( const RTInterval     & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTInterval( const RTInterval     &,
					const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTInterval.inl>
#endif

#endif // __RTInterval_h__
