/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTOutSignal_inl__
#define __RTOutSignal_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTOutSignal_h__
#include <RTOutSignal.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

RTS_INLINE RTOutSignal::RTOutSignal( RTProtocol           * port,
				     int                    signal,
				     const void           * data,
				     const RTObject_class * type )
    : _port  ( port   )
    , _signal( signal )
    , _data  ( data   )
    , _type  ( type   )
{
}

RTS_INLINE int RTOutSignal::invoke( RTMessage * replyBuffers )
{
    return _port->invoke( replyBuffers, _signal, _data, _type );
}

RTS_INLINE int RTOutSignal::invokeAt( int index, RTMessage * replyBuffer )
{
    return _port->invokeAt( index, replyBuffer, _signal, _data, _type );
}

RTS_INLINE int RTOutSignal::reply( void )
{
    return _port->reply( _signal, _data, _type );
}

RTS_INLINE int RTOutSignal::send( int priority )
{
    return _port->send( _signal, _data, _type, priority );
}

RTS_INLINE int RTOutSignal::sendAt( int index, int priority )
{
    return _port->sendAt( index, _signal, _data, _type, priority );
}

#endif // __RTOutSignal_inl__
