/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSequenceOf_h__
#define __RTSequenceOf_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTSequenceOf : public RTDataObject
{
protected:
    void                    spaceClean( void );

public:
    int                     size;
    RTDataObject         ** array;

    explicit                RTSequenceOf( int _size = 0 );
			    RTSequenceOf( const RTSequenceOf & );
			    RTSequenceOf( int                   _size,
					  const RTDataObject ** _contents );

    virtual                 ~RTSequenceOf( void );

    RTS_INLINE RTDataObject & at( int ) const;
    RTDataObject          & operator[]( int ) const;
    RTSequenceOf          & operator=( const RTSequenceOf & );

    virtual int             operator==( const RTDataObject & ) const;

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTSequenceOf ( RTSequenceOf::classData )
};

struct RTTypedValue_RTSequenceOf
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTSequenceOf( const RTSequenceOf & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTSequenceOf( const RTSequenceOf &,
					  const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTSequenceOf.inl>
#endif

#endif // __RTSequenceOf_h__
