#! perl -w

# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



sub fatal
{
    print STDERR "$_[0]\n";
    exit 1;
}

$suffix = '.o';

$#ARGV >= 1 || &fatal( "Usage: ${0} archive objects ..." );

$perl   = $^X;
$script = "\"print unless m/^(addlib|addmod) /;\"";

$lib = shift @ARGV;

unlink( $lib );

if( ! open( LIB1, "| libppc | $perl -n -e $script" ) )
{
    &fatal( "Cannot open | libppc \n" );
}

print LIB1 "create $lib\n";

foreach $arg ( @ARGV )
{
    if( $arg !~ m{^%(.*)$} )
    {
	print LIB1 "addmod $arg\n";
    }
    else
    {
	$list = $1;
	if( ! open( LIST, "<$list" ) )
	{
	    &fatal( "Cannot open '$list'\n" );
	}

	while( <LIST> )
	{
	    chomp;
	    print LIB1 "addmod $_$suffix\n";
	}

	close( LIST );
    }
}

print LIB1 "save\n";
print LIB1 "end\n";

close( LIB1 );

exit 0;
