/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTActor.h"
#pragma implementation "RTActor.inl"
#endif

#include <RTActor.h>
#include <RTDiag.h>
#include <RTRelayPort.h>

RTActor::~RTActor( void )
{
    delete [] state;
    delete [] relays;

    // removeAllImports should have been called,
    // so we should not have to do anything now
    if( importList != (RTImportList *)0 )
	RTDiag::panic( "~RTActor: importList not empty" );

    context()->countActorDestroy();

#ifdef _lint
    rts           = (RTController    *)0;
    homeReference = (RTActorRef      *)0;
#if SUSPEND
    suspendMsgs   = (RTMessage       *)0;
#endif
    importList    = (RTImportList    *)0;
    msg           = (const RTMessage *)0;
#if OBSERVABLE
    probe         = (RTActorProbe    *)0;
#endif
#endif // _lint
}
