/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTDiag.h>

RTActor::RTActor( const RTActor & )
    : rts          ( (RTController    *)0 )
    , homeReference( (RTActorRef      *)0 )
    , homeIndex    (                    0 )
    , relays       ( (RTRelayPort     *)0 )
#if DEFER_IN_ACTOR
    , deferredQ    (                      )
#endif
#if SUSPEND
    , suspendMsgs  ( (RTMessage       *)0 )
#endif
    , importList   ( (RTImportList    *)0 )
    , state        ( (State           *)0 )
    , msg          ( (const RTMessage *)0 )
#if OBSERVABLE
    , probe        ( (RTActorProbe    *)0 )
#endif
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTActor( const RTActor & )'" );
}

RTActor & RTActor::operator=( const RTActor & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTActor::operator=( const RTActor & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
