/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorProbe.h>
#include <RTMain.h>
#include <RTMemoryUtil.h>
#include <RTString.h>

RTActorProbe::RTActorProbe( RTDebugger * debugger,
			    int          id,
			    const char * strPath,
			    int          actorIndex )
    : RTProbe     ( debugger, id, strPath, actorIndex )
    , _chainOrigin(                    0 )
    , _chainTrans ( (const char      *)0 )
    , _chainMsg   ( (const RTMessage *)0 )
    , _chainParent(                    0 )
    , _chainState (                    0 )
    , _fieldList  ( (FieldEntry      *)0 )
{
}

RTActorProbe::FieldEntry::FieldEntry( const char * aName, const char * aValue )
    : varName ( RTMemoryUtil::strdup( aName ) )
    , varValue( (char                     *)0 )
    , next    ( (FieldEntry               *)0 )
{
    if( aValue != (const char *)0 )
	varValue = RTMemoryUtil::strdup( aValue );
}
