/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTDiag.h>
#include <RTImportList.h>

int RTActorRef::indexOf( const RTActor * actor ) const
{
    int replication = _info->replication;
    int index       = -1;

    if( replication <= 0 )
    {
	// excluded reference
    }
    else if( _info->kind == RTComponentDescriptor::Imported )
    {
	RTImportList * entry;

	if( replication == 1 )
	{
	    entry = (RTImportList *)_contents;

	    if( entry->used.reference == this && entry->used.actor == actor )
		index = 0;
	}
	else for( entry = actor->importList; ; entry = entry->used.next )
	{
	    if( entry == (RTImportList *)0 )
		break;

	    if( entry->used.reference == this )
	    {
		RTAssert( entry->used.actor == actor );

		RTImportList::Unused * head;
		RTImportList         * first;

		head  = (RTImportList::Unused *)_contents;
		first = (RTImportList *)(void *)&head[ 1 ];

		index = entry - first; //lint !e946 !e947
		break;
	    }
	}
    }
    else
    {
	index = actor->getIndex();

	if( index < 0 || index >= replication || (*this)[ index ] != actor )
	    index = -1;
    }

    return index;
}
