/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>
#include <RTObject_class.h>
#include <RTUnknownObject.h>

int RTAsciiDecoding::get( void ** data, RTObject_class const ** type )
{
    char name[ 200 ];

    if( getName( name, (int)sizeof( name ) ) == 0 )
	return 0;

    if( (*type = RTObject_class::lookup( name )) == (const RTObject_class *)0 )
    {
	RTUnknownObject * unknown = getUnknown( name );

	if( unknown == (RTUnknownObject *)0 )
	    return 0;

	*data = (void *)unknown;
	*type = &RTType_RTUnknownObject;

	return 1;
    }

    *data = (*type)->allocate();

    if( *data == (void *)0 )
	return 0; // no space?

    (*type)->init( *data );

    if( (*type)->decode( *data, this ) == 0 )
    {
	(*type)->destroy( *data, RTObject_class::DestroyAndDeallocate );
	return 0;
    }

    return 1;
}
