/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTController.h"
#pragma implementation "RTController.inl"
#endif

#include <RTController.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTSyncObject.h>
#endif
#include <RTTimerNode.h>

RTController::~RTController( void )
{
#if OTRTSDEBUG != DEBUG_NONE
    debugger()->deregisterRTS( this );
#endif

    short       bits;
    short       priority;
    RTMessage * all;

#if USE_THREADS
    delete _sync;
    acceptIncoming();
#endif

    for( bits = internalBits; bits != 0; )
    {
	priority = topPriority[ bits ];
	bits ^= 1 << priority;
	all = internalQ[ priority ].dqAll();
	resourceMgr.msgFree( all );
    }

    resourceMgr.msgFree( freeList );

#if ! DEFER_IN_ACTOR
    all = deferredQ.dqAll();
    resourceMgr.msgFree( all );
#endif

    while( freeTimerList != (RTTimerNode *)0 )
    {
	RTTimerNode * node = freeTimerList;

	freeTimerList = node->next;

	delete node;
    }

#ifdef _lint
    _name         = (const char   *)0;
#if OTRTSDEBUG != DEBUG_NONE
    _debugger     = (RTDebugger   *)0;
    _prev         = (RTController *)0;
    _next         = (RTController *)0;
#endif
    freeList      = (RTMessage    *)0;
    freeTimerList = (RTTimerNode  *)0;
    replyBuffer   = (RTMessage    *)0;
#endif
}
