/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTMessage.h>
#include <RTMutex.h>

void RTController::peer_receive( RTMessage * msg )
{
    int          priority = (int)msg->priority;
    RTMessageQ * queue    = &incomingQ[ priority ];

    _mutex->enter();

    queue->nqTail( msg );

    short old_bits = incomingBits;

    incomingBits = (short)( old_bits | ( 1 << priority ) );

    _mutex->leave();

    if( old_bits == 0 && phase() == RTJob::running )
	wakeup();
}
