/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTDebugger.h>

#if USE_THREADS
#include <RTMutex.h>
#endif

void RTDebugger::addFieldValue( const char * variable, // ESV name
				const char * value,    // value or 0 if read
				int          probeNr )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTActorProbe * probe = (RTActorProbe *)probes[ probeNr ];

    if( probe != (RTActorProbe *)0 )
    {
	RTActor * actor = probe->actor();

	if( actor != (RTActor *)0 )
	{
	    probe->addFieldValue( variable, value );
	    sendProbeSignal( actor, Synchronous );
	}
    }

#if USE_THREADS
    _mutex->leave();
#endif
}
