/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

void RTDebugger::deregisterRTS( RTController * task )
{
#if USE_THREADS
    _mutex->enter();
#endif

    if( tasks == task )
	tasks = ( task->_next != task ) ? task->_next
					: (RTController *)0;

    task->_next->_prev = task->_prev;
    task->_prev->_next = task->_next;

    task->_next  = task;
    task->_prev  = task;
    task->_state = RTController::detached;

#if USE_THREADS
    _mutex->leave();
#endif
}
