/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>

int RTDebugger::evtPresence( int             probeNr,
			     int             actorIndex,
			     const RTActor * actor,
			     int             observerId,
			     int             daemonId )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventPresence,
					       probeNr,
					       actorIndex );

    if( observerId < 0 )
	getTimestamp( eventInfo->timestamp );

    eventInfo->actor      = actor;
    eventInfo->info       = actor != (const RTActor *)0
			    ? actor->getActorData()
			    : (const RTActor_class *)0;
    eventInfo->observerId = observerId;
    eventInfo->daemonId   = daemonId;

    return addEvent( eventInfo );
}
