/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTElasticArray.h>

void RTElasticArray::resize( int min_size )
{
    if( min_size < 0 )
	min_size = 0;

    if( _size == min_size )
	return;

    int new_size;

    if( _size < min_size )
	new_size = min_size;
    else
    {
	for( new_size = _size; new_size > min_size; --new_size )
	    if( _contents[ new_size - 1 ] != (void *)0 )
		break;

	if( _size == new_size )
	    return;

	_size = new_size;
    }

    if( new_size == 0 )
    {
	delete [] _contents;
	_size     = 0;
	_contents = (void **)0;
    }
    else
    {
	void ** old_contents = _contents;
	int     i;

	_contents = new void * [(unsigned)new_size];

	for( i = 0; i < _size; ++i )
	    _contents[i] = old_contents[i];

	_size = new_size;

	for( ; i < _size; ++i )
	    _contents[i] = (void *)0;

	delete [] old_contents;
    }
}
