/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTArray_class.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static void array_init( void                 * target,
			const RTObject_class * element,
			int                    size,
			int                    indirect )
{
    RTArray_class array( size, element );

    if( indirect == 0 )
	array.init( target );
    else
    {
	void * target_array = array.allocate();

	*(void **)target = target_array;

	if( target_array != (void *)0 )
	    array.init( target_array );
    }
}

void RTFieldDescriptor::init( void * target ) const
{
    void * field = RTObjectOf( void, offset, target );

    if( modifier == (const RTTypeModifier *)0 )
	type->init( field );
    else
	array_init( field, type,
		    (*modifier->_num_elements_func)( modifier, target ),
		    modifier->_indirect );
}
