/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFormat.h>

static const char hex[] = "0123456789abcdef";

int RTFormat::_void( const void * address,
		     char       * buffer,
		     int          bufferSize )
{
    unsigned long   value  = (unsigned long)address;
    char            reversed[ 2 * (int)sizeof( void * ) + 3 ];
    char          * cursor = reversed;

    do
	*cursor++ = hex[ value & 0xFUL ];
    while( (value >>= 4) > 0UL );

    *cursor++ = 'x';
    *cursor++ = '0';

    int size = cursor - reversed; //lint !e946 !e947

    if( size + 1 > bufferSize )
	return 0;

    while( cursor != reversed )
	*buffer++ = *--cursor;

    *buffer = '\0';

    return size;
}
