/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLayerConnector.h>
#include <RTMemoryUtil.h>

void RTLayerConnector::parseService( const char * name, NameBuffer & buffer )
{
    const char * colon = RTMemoryUtil::strchr( name, ':' );
    int          length;

    if( colon == (const char *)0 )
    {
	buffer.value = defaultService;
    }
    else if( (length = colon - name) //lint !e946 !e947
		     < (int)sizeof( buffer.small_buffer ) )
    {
	RTMemoryUtil::strcpy( buffer.small_buffer, name, length );
	buffer.value = buffer.small_buffer;
    }
    else
    {
	delete [] buffer.large_buffer;

	buffer.large_buffer = new char [ (unsigned)length + 1U ];
	RTMemoryUtil::strcpy( buffer.large_buffer, name, length );
	buffer.value = buffer.large_buffer;
    }
}
