/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLocalConnector.h>
#include <RTProtocol.h>

void RTLocalConnector::SapNode::deregister( RTController * context )
{
    RTLocalConnector::unbind( context, *initial.sap );

    Request * request = &initial;
    Request * chain;

    do
    {
	request->start = 0;
	request->limit = 0;
    }
    while( (request = request->chain) != (Request *)0 );

    // remove any following requests
    for( request = initial.chain; request != (Request *)0; request = chain )
    {
	node->remove( context, request );

	chain = request->chain;

	delete request;
    }

    node->remove( context, &initial );
    node->remove( context, this );

    delete this;
}
