/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTMessage.h>

int RTMessage::defer( void ) const
{
    RTController * controller = context();

    controller->trace( RTController::CommDefer, this, (const void *)0 );

    // Ensure that the message has not already been deferred
    if( isDeferred() != 0 )
    {
	controller->setError( RTController::alreadyDeferred,
			      RTController::CommDefer, this, (const void *)0 );
	return 0;
    }

    // Ensure that the message was not invoked.
    if( controller->getReplyBuffer() != (RTMessage *)0 )
    {
	controller->setError( RTController::deferInvoke,
			      RTController::CommDefer, this, (const void *)0 );
	return 0;
    }

    RTConstCast( RTMessage, this )->setDeferred();

    return 1;
}
