/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

void RTstruct_copy( const RTObject_class * type,
		    void                 * target,
		    const void           * source )
{
    const RTObject_class * super = type->_super;

    if( super != (const RTObject_class *)0 )
	super->copy( (*type->_super_accessor)(                    target   ),
		     (*type->_super_accessor)( RTConstCast( void, source ) ) );

    int                       count = type->_num_fields;
    const RTFieldDescriptor * field = type->_fields;

    for( ; --count >= 0; ++field )
	field->copy( target, source );
}
