/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void uchar_init( const RTObject_class *, void * target )
{
    *(unsigned char *)target = '\0';
}

static void uchar_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(unsigned char *)target = *(const unsigned char *)source;
}

#if OBJECT_DECODE
static int uchar_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_uchar( *(unsigned char *)target );
}
#endif

#if OBJECT_ENCODE
static int uchar_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_uchar( *(const unsigned char *)source );
}
#endif

const RTObject_class RTType_RTuchar =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTuchar",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned char ),
    uchar_init,
    uchar_copy,
#if OBJECT_DECODE
    uchar_decode,
#endif
#if OBJECT_ENCODE
    uchar_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller RTuchar_installer( RTType_RTuchar );
#endif
