/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTMemoryUtil.h>
#include <RTObject_class.h>
#include <RTPointer.h>
#include <RTnew.h>

static RTByteBlock * _access( RTPointer * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTPointer;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTPointer( *(const RTPointer *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    RTPointer * data = (RTPointer *)target;
    void      * block;

    if( coding->get_address( block ) == 0 )
	return 0;

    data->length   = 0;
    data->Contents = (char *)block;

    return 1;
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    return coding->put_address( *(const RTPointer *)source );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTPointer",
	(RTFieldOffset)0,
	&RTPointer::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTPointer::classData =
{
    &RTType_RTByteBlock,
    (RTSuperAccessFunction)_access,
    "RTPointer",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTPointer ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTPointer_installer( RTType_RTPointer );
#endif

const RTObject_class * RTPointer::getClassData( void ) const
{
    return &RTPointer::classData;
}
