/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>
#include <RTTypedValue.h>
#include <RTnew.h>

// sample type descriptor

class Sample2
{
public:
    int     x;
    int   * y;

	    Sample2( void );
	    Sample2( const Sample2 & );
    virtual ~Sample2( void );
};

static int y_number( const RTTypeModifier *, const void * source )
{
    const Sample2 * sample = (const Sample2 *)source;

    return sample->x;
}

static const RTTypeModifier int_pointer =
{
    y_number, 0, 1
};

static void Sample2_init( const RTObject_class *, void * target )
{
    (void)new( target ) Sample2;
}

static void Sample2_copy( const RTObject_class *,
			  void                 * target,
			  const void           * source )
{
    (void)new( target ) Sample2( *(const Sample2 *)source );
}

static void Sample2_destroy( const RTObject_class *, void * target )
{
    ((Sample2 *)target)->~Sample2();
}

static const RTFieldDescriptor Sample2_fields[] =
{
    {
	"x",
	RTOffsetOf( Sample2, x ),
	&RTType_int,
	(const RTTypeModifier *)0
    },
    {
	"y",
	RTOffsetOf( Sample2, y ),
	&RTType_int, &int_pointer
    }
};

static const RTObject_class Sample2_descriptor =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "Sample2",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( Sample2 ),
    Sample2_init,
    Sample2_copy,
#if OBJECT_DECODE
    RTstruct_decode,
#endif
#if OBJECT_ENCODE
    RTstruct_encode,
#endif
    Sample2_destroy,
    2, Sample2_fields
};

RTTypedValue new_RTTypedValue( const Sample2 & value )
{
    return RTTypedValue( &value, &Sample2_descriptor );
}
