/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorRef.h>
#include <RTDiag.h>
#include <RTSuperActor.h>

//lint -save -e1738
RTSuperActor::RTSuperActor( const RTSuperActor & other )
    : RTActor( other.context(), other.getReference() )
    , specials       (                   )
    , application    (                   )
    , frame          (                   )
    , timer          (                   )
#if USE_THREADS
    , timerController( (RTController *)0 )
    , timerThread    ( (RTThread     *)0 )
#endif
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTSuperActor( const RTSuperActor & )'" );
}
//lint -restore

RTSuperActor & RTSuperActor::operator=( const RTSuperActor & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTSuperActor::operator=( const RTSuperActor & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
