/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>
#include <RTTimerActor.h>
#include <RTTimerController.h>

void RTTimerController::mainLoop( void )
{
    startup();

    enter( RTJob::running );

    while( phase() != RTJob::finished )
    {
	// process clock ticks;
	RTActor * agent = RTTimerActor::soleInstance();

	if( agent != (RTActor *)0 )
	    agent->rtsBehavior( RTInterruptSignal, RTControlPort );

	if( dispatch( Background ) != OneDelivered )
	    waitForEvents();
    }

    shutdown();
}
