/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTimerList.h>
#include <RTTimerNode.h>

int RTTimerList::insert( RTTimerNode * node )
{
    if( used >= space )
    {
	space += 128U;

	RTTimerNode ** new_nodes = new RTTimerNode * [ (unsigned)space ];

	for( unsigned i = used; i-- != 0U; )
	    new_nodes[ i ] = nodes[ i ];

	delete [] nodes;

	nodes = new_nodes;
    }

    nodes[ node->link.index = used++ ] = node;

    unsigned index;
    unsigned parent_index;

    for( index = node->link.index; ; index = parent_index )
    {
	if( index == 0U )
	    return 1;

	RTTimerNode * parent_node = nodes[ parent_index = ( index - 1U ) >> 1 ];

	if( node->expireTime >= parent_node->expireTime ) //lint !e909
	    break;

	// swap node & parent_node
	nodes[ node       ->link.index = parent_index ] = node;
	nodes[ parent_node->link.index =        index ] = parent_node;
    }

    return 0;
}
