/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTTimespec.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTTimespec;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTTimespec( *(const RTTimespec *)source );
}

static const RTFieldDescriptor fieldData[] =
{
    {
	"tv_sec",
	RTOffsetOf( RTTimespec, tv_sec ),
	&RTType_long,
	(const RTTypeModifier *)0
    },
    {
	"tv_nsec",
	RTOffsetOf( RTTimespec, tv_nsec ),
	&RTType_long,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTTimespec::classData =
{
    (const RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTTimespec",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTTimespec ),
    _init,
    _copy,
#if OBJECT_DECODE
    RTstruct_decode,
#endif
#if OBJECT_ENCODE
    RTstruct_encode,
#endif
    RTnop_destroy,
    2, fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTTimespec_installer( RTType_RTTimespec );
#endif
