/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTTimerActor.h>
#include <RTTiming.h>

void Timing::Base::adjustTimeEnd( const RTTimespec & delta )
{
    RTController * controller = context();
    RTTimerActor * timerActor = RTTimerActor::soleInstance();

    if( timerActor == (RTTimerActor *)0 )
    {
	controller->setError( RTController::noConnect,
			      RTController::TimerInform,
			      this,
			      (const void *)0 );
    }
    else
    {
	timerActor->adjustTimeEnd( delta, controller );
    }
}
