/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>
#include <RTTimespec.h>

void RTSyncObject::timedwait( const RTTimespec & expireTime )
{
    RTTimespec now;

    RTTimespec::getclock( now );

    if( expireTime <= now )
	return;

    RTTimespec expire( expireTime );

    expire -= now;

    KnTimeVal timeout;

    timeout.tmSec  = expire.tv_sec;
    timeout.tmNSec = expire.tv_nsec;

    int rc = threadSemWait( &sem, &timeout );

    if( rc != K_OK && rc != K_ETIMEOUT )
	RTDiag::panic( "threadSemWait(timed)" );
}
