/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTWinCE.h>

RTConsole * RTConsole::soleInstance = (RTConsole *)0;
RTWinCE   * RTWinCE  ::soleInstance = (RTWinCE   *)0;

RTConsole::RTConsole( HWND hWnd, int rows, int cols )
    : window    (           hWnd )
    , font      (       (HFONT)0 )
    , haveFocus (              0 )
    , caretState( CaretDestroyed )
{
    RTAssert( soleInstance == (RTConsole *)0 );
    soleInstance = this;

    input.lines     = 0;
    input.head      = 0;
    input.tail      = 0;
    input.data[ 0 ] = '\n';

    HDC        hDC;
    LOGFONT    lf;
    HGDIOBJ    oldFont;
    TEXTMETRIC metrics;
    int        i;

    memset( (char *)&lf, 0, sizeof( lf ) );

    lf.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
    lf.lfHeight         = 13;

    font    = CreateFontIndirect( &lf );
    hDC     = GetDC( window );
    oldFont = SelectObject( hDC, font );

    GetTextMetrics( hDC, &metrics );

    if( oldFont != (HGDIOBJ)0 )
	(void)SelectObject( hDC,oldFont );

    ReleaseDC( window, hDC );

    buffer.rows = rows;
    buffer.cols = cols;
    buffer.data = new TCHAR [ rows * cols ];

    for( i = rows * cols; --i >= 0; )
	buffer.data[ i ] = TEXT( ' ' );

    cursor.row = 0;
    cursor.col = 0;

    character.height = metrics.tmHeight;
    character.width  = metrics.tmMaxCharWidth;

    screen.top  = 0;
    screen.left = 0;

    resize();
}
